#ifndef ROD_H
#define ROD_H

#include <iostream>
#include <iomanip>

#define ROD_MAX_HEIGHT 15

class Rod
{
	public:
		Rod( int numdiscs = 0 ) : _numdiscs( numdiscs )
		{
			int i;
			for( i = 0; i < _numdiscs; i++ )
				_discs[ i ] = _numdiscs - i;
			for( ; i < ROD_MAX_HEIGHT; i++  )
				_discs[ i ] = 0;
		}

		void push( int size )
		{
			_discs[ _numdiscs ] = size;
			_numdiscs++;
		}

		int pop()
		{
			int ret = _discs[ _numdiscs - 1 ];
			_discs[ _numdiscs - 1 ] = 0;
			_numdiscs--;
			return ret;
		}

		int numDiscs()
		{
			return _numdiscs;
		}

		void print()
		{
			for( int i=0; i < ROD_MAX_HEIGHT; i++ )
			{
				if( i < _numdiscs )
					std::cout << std::setw( 2 ) << _discs[ i ] << "|";
				else
					std::cout <<  "==|";
			}
			std::cout << std::endl;
		}

	private:
		int _numdiscs;
		int _discs[ ROD_MAX_HEIGHT ];
};


#endif
